- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# postgresql_copy – Copy data between a file/program and a PostgreSQL table

New in version 2.9.

- Synopsis

- Requirements

- Parameters

- Notes

- See Also

- Examples

- Return Values

- Status

## Synopsis

- Copy data between a file/program and a PostgreSQL table.

## Requirements

The below requirements are needed on the host that executes this module.

- psycopg2

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
ca_cert string |  | Specifies the name of a file containing SSL certificate authority (CA) certificate(s). If the file exists, the server's certificate will be verified to be signed by one of these authorities. aliases: ssl_rootcert
columns list / elements=string |  | List of column names for the src/dst table to COPY FROM/TO. aliases: column
copy_from path |  | Copy data from a file to a table (appending the data to whatever is in the table already). Mutually exclusive with copy_to and src. aliases: from
copy_to path |  | Copy the contents of a table to a file. Can also copy the results of a SELECT query. Mutually exclusive with copy_from and dst. aliases: to
db string |  | Name of database to connect to. aliases: login_db
dst string |  | Copy data to dst=tablename from copy_from=/path/to/data.file. Used with copy_from only. aliases: destination
login_host string |  | Host running the database.
login_password string |  | The password used to authenticate with.
login_unix_socket string |  | Path to a Unix domain socket for local connections.
login_user string | Default: "postgres" | The username used to authenticate with.
options dictionary |  | Options of COPY command. See the full list of available options https://www.postgresql.org/docs/current/sql-copy.html.
port integer | Default: 5432 | Database port to connect to. aliases: login_port
program boolean | Choices: no ← yes | Mark src/dst as a program. Data will be copied to/from a program. See block Examples and PROGRAM arg description https://www.postgresql.org/docs/current/sql-copy.html.
session_role string |  | Switch to session_role after connecting. The specified session_role must be a role that the current login_user is a member of. Permissions checking for SQL commands is carried out as though the session_role were the one that had logged in originally.
src string |  | Copy data from copy_from to src=tablename. Used with copy_to only. aliases: source
ssl_mode string | Choices: allow disable prefer ← require verify-ca verify-full | Determines whether or with what priority a secure SSL TCP/IP connection will be negotiated with the server. See https://www.postgresql.org/docs/current/static/libpq-ssl.html for more information on the modes. Default of `prefer` matches libpq default.

## Notes

Note

- Supports PostgreSQL version 9.4+.

- COPY command is only allowed to database superusers.

- if check_mode=yes, we just check the src/dst table availability and return the COPY query that actually has not been executed.

- If i(check_mode=yes) and the source has been passed as SQL, the module will execute it and rolled the transaction back but pay attention it can affect database performance (e.g., if SQL collects a lot of data).

- The default authentication assumes that you are either logging in as or sudo’ing to the `postgres` account on the host.

- To avoid “Peer authentication failed for user postgres” error, use postgres user as a become_user.

- This module uses psycopg2, a Python PostgreSQL database adapter. You must ensure that psycopg2 is installed on the host before using this module.

- If the remote host is the PostgreSQL server (which is the default case), then PostgreSQL must also be installed on the remote host.

- For Ubuntu-based systems, install the postgresql, libpq-dev, and python-psycopg2 packages on the remote host before using this module.

- The ca_cert parameter requires at least Postgres version 8.4 and psycopg2 version 2.4.3.

## See Also

See also

COPY command reference

  Complete reference of the COPY command documentation.

## Examples

    - name: Copy text TAB-separated data from file /tmp/data.txt to acme table
      postgresql_copy:
        copy_from: /tmp/data.txt
        dst: acme

    - name: Copy CSV (comma-separated) data from file /tmp/data.csv to columns id, name of table acme
      postgresql_copy:
        copy_from: /tmp/data.csv
        dst: acme
        columns: id,name
        options:
          format: csv

    - name: >
        Copy text vertical-bar-separated data from file /tmp/data.txt to bar table.
        The NULL values are specified as N
      postgresql_copy:
        copy_from: /tmp/data.csv
        dst: bar
        options:
          delimiter: '|'
          null: 'N'

    - name: Copy data from acme table to file /tmp/data.txt in text format, TAB-separated
      postgresql_copy:
        src: acme
        copy_to: /tmp/data.txt

    - name: Copy data from SELECT query to/tmp/data.csv in CSV format
      postgresql_copy:
        src: 'SELECT * FROM acme'
        copy_to: /tmp/data.csv
        options:
          format: csv

    - name: Copy CSV data from my_table to gzip
      postgresql_copy:
        src: my_table
        copy_to: 'gzip > /tmp/data.csv.gz'
        program: yes
        options:
          format: csv

    - name: >
        Copy data from columns id, name of table bar to /tmp/data.txt.
        Output format is text, vertical-bar-separated, NULL as N
      postgresql_copy:
        src: bar
        columns:
        - id
        - name
        copy_to: /tmp/data.csv
        options:
          delimiter: '|'
          null: 'N'

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
dst string | always | Data destination. Sample: /tmp/data.csv
queries string | always | List of executed queries. Sample: ["COPY test_table FROM '/tmp/data_file.txt' (FORMAT csv, DELIMITER ',', NULL 'NULL')"]
src string | always | Data source. Sample: mytable

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by the Ansible Community. [community]

### Authors

- Andrew Klychkov (@Andersson007)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.